6638: Build current version of arvados-src, not github master.
[arvados-dev.git] / jenkins / run-build-packages.sh
1 #!/bin/bash
2
3
4 read -rd "\000" helpmessage <<EOF
5 $(basename $0): Build Arvados packages
6
7 Syntax:
8         WORKSPACE=/path/to/arvados $(basename $0) [options]
9
10 Options:
11
12 --build-bundle-packages  (default: false)
13     Build api server and workbench packages with vendor/bundle included
14 --debug
15     Output debug information (default: false)
16 --target
17     Distribution to build packages for (default: debian7)
18
19 WORKSPACE=path         Path to the Arvados source tree to build packages from
20
21 EOF
22
23 EXITCODE=0
24 DEBUG=${ARVADOS_DEBUG:-0}
25 BUILD_BUNDLE_PACKAGES=0
26 TARGET=debian7
27
28 PARSEDOPTS=$(getopt --name "$0" --longoptions \
29     help,build-bundle-packages,debug,target: \
30     -- "" "$@")
31 if [ $? -ne 0 ]; then
32     exit 1
33 fi
34
35 eval set -- "$PARSEDOPTS"
36 while [ $# -gt 0 ]; do
37     case "$1" in
38         --help)
39             echo >&2 "$helpmessage"
40             echo >&2
41             exit 1
42             ;;
43         --target)
44             TARGET="$2"; shift
45             ;;
46         --debug)
47             DEBUG=1
48             ;;
49         --build-bundle-packages)
50             BUILD_BUNDLE_PACKAGES=1
51             ;;
52         --)
53             if [ $# -gt 1 ]; then
54                 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
55                 exit 1
56             fi
57             ;;
58     esac
59     shift
60 done
61
62 STDOUT_IF_DEBUG=/dev/null
63 STDERR_IF_DEBUG=/dev/null
64 DASHQ_UNLESS_DEBUG=-q
65 if [[ "$DEBUG" != 0 ]]; then
66     STDOUT_IF_DEBUG=/dev/stdout
67     STDERR_IF_DEBUG=/dev/stderr
68     DASHQ_UNLESS_DEBUG=
69 fi
70
71 debug_echo () {
72     echo "$@" >"$STDOUT_IF_DEBUG"
73 }
74
75 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
76
77 PYTHON2_VERSION=2.7
78 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
79
80 case "$TARGET" in
81     debian7)
82         FORMAT=deb
83         PYTHON2_PACKAGE=python$PYTHON2_VERSION
84         PYTHON2_PKG_PREFIX=python
85         PYTHON3_PACKAGE=python$PYTHON3_VERSION
86         PYTHON3_PKG_PREFIX=python3
87         PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
88             oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
89             rsa uritemplate httplib2 ws4py \
90             virtualenv pykka apache-libcloud requests six pyexecjs jsonschema \
91             ciso8601 pycrypto backports.ssl_match_hostname pycurl llfuse)
92         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
93         ;;
94     debian8)
95         FORMAT=deb
96         PYTHON2_PACKAGE=python$PYTHON2_VERSION
97         PYTHON2_PKG_PREFIX=python
98         PYTHON3_PACKAGE=python$PYTHON3_VERSION
99         PYTHON3_PKG_PREFIX=python3
100         PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
101             oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
102             rsa uritemplate httplib2 ws4py \
103             virtualenv pykka apache-libcloud requests six pyexecjs jsonschema \
104             ciso8601 pycrypto backports.ssl_match_hostname pycurl llfuse)
105         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
106         ;;
107     ubuntu1204)
108         FORMAT=deb
109         PYTHON2_PACKAGE=python$PYTHON2_VERSION
110         PYTHON2_PKG_PREFIX=python
111         PYTHON3_PACKAGE=python$PYTHON3_VERSION
112         PYTHON3_PKG_PREFIX=python3
113         PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
114             oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
115             rsa uritemplate httplib2 ws4py \
116             virtualenv pykka apache-libcloud requests six pyexecjs jsonschema \
117             ciso8601 pycrypto backports.ssl_match_hostname pycurl llfuse)
118         PYTHON3_BACKPORTS=(docker-py six requests websocket-client)
119         ;;
120     ubuntu1404)
121         FORMAT=deb
122         PYTHON2_PACKAGE=python$PYTHON2_VERSION
123         PYTHON2_PKG_PREFIX=python
124         PYTHON3_PACKAGE=python$PYTHON3_VERSION
125         PYTHON3_PKG_PREFIX=python3
126         PYTHON_BACKPORTS=(pyasn1==0.1.7 pyasn1-modules==0.0.5 llfuse ciso8601 \
127             google-api-python-client six uritemplate oauth2client httplib2 \
128             rsa apache-libcloud pycurl backports.ssl_match_hostname)
129         PYTHON3_BACKPORTS=(docker-py requests websocket-client)
130         ;;
131     centos6)
132         FORMAT=rpm
133         PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
134         PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
135         PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
136         PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
137         PYTHON_BACKPORTS=(python-gflags pyvcf google-api-python-client \
138             oauth2client pyasn1==0.1.7 pyasn1-modules==0.0.5 \
139             rsa uritemplate httplib2 ws4py \
140             pykka apache-libcloud requests six pyexecjs jsonschema \
141             ciso8601 pycrypto backports.ssl_match_hostname pycurl
142             python-daemon lockfile llfuse)
143         PYTHON3_BACKPORTS=(docker-py six requests)
144         export PYCURL_SSL_LIBRARY=nss
145         ;;
146     *)
147         echo -e "$0: Unknown target '$TARGET'.\n" >&2
148         exit 1
149         ;;
150 esac
151
152
153 if ! [[ -n "$WORKSPACE" ]]; then
154   echo >&2 "$helpmessage"
155   echo >&2
156   echo >&2 "Error: WORKSPACE environment variable not set"
157   echo >&2
158   exit 1
159 fi
160
161 # Test for fpm
162 fpm --version >/dev/null 2>&1
163
164 if [[ "$?" != 0 ]]; then
165   echo >&2 "$helpmessage"
166   echo >&2
167   echo >&2 "Error: fpm not found"
168   echo >&2
169   exit 1
170 fi
171
172 find_easy_install() {
173     for version_suffix in "$@"; do
174         if "easy_install$version_suffix" --version >/dev/null 2>&1; then
175             echo "easy_install$version_suffix"
176             return 0
177         fi
178     done
179     cat >&2 <<EOF
180 $helpmessage
181
182 Error: easy_install$1 (from Python setuptools module) not found
183
184 EOF
185     exit 1
186 }
187
188 EASY_INSTALL2=$(find_easy_install -$PYTHON2_VERSION "")
189 EASY_INSTALL3=$(find_easy_install -$PYTHON3_VERSION 3)
190
191 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
192 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`"  # absolutized and normalized
193 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
194   # error; for some reason, the path is not accessible
195   # to the script (e.g. permissions re-evaled after suid)
196   exit 1  # fail
197 fi
198
199 debug_echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
200 debug_echo "Workspace is $WORKSPACE"
201
202 format_last_commit_here() {
203     local format=$1; shift
204     TZ=UTC git log -n1 --first-parent "--format=format:$format" .
205 }
206
207 version_from_git() {
208   # Generates a version number from the git log for the current working
209   # directory, and writes it to stdout.
210   local git_ts git_hash
211   declare $(format_last_commit_here "git_ts=%ct git_hash=%h")
212   echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
213 }
214
215 nohash_version_from_git() {
216     version_from_git | cut -d. -f1-3
217 }
218
219 timestamp_from_git() {
220     format_last_commit_here "%ct"
221 }
222
223 handle_python_package () {
224   # This function assumes the current working directory is the python package directory
225   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
226     # This package doesn't need rebuilding.
227     return
228   fi
229   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
230   python setup.py $DASHQ_UNLESS_DEBUG sdist
231 }
232
233 handle_ruby_gem() {
234     local gem_name=$1; shift
235     local gem_version=$(nohash_version_from_git)
236
237     if [ -e "${gem_name}-${gem_version}.gem" ]; then
238         # This gem doesn't need rebuilding.
239         return
240     fi
241
242     find -maxdepth 1 -name "${gem_name}-*.gem" -delete
243
244     # -q appears to be broken in gem version 2.2.2
245     gem build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
246
247     fpm_build "$gem_name"-*.gem "" "Curoverse, Inc." gem "" \
248         --prefix "$FPM_GEM_PREFIX"
249     mv -t "$WORKSPACE/packages/$TARGET/" "$gem_name"*."$FORMAT"
250 }
251
252 # Build packages for everything
253 fpm_build () {
254   # The package source.  Depending on the source type, this can be a
255   # path, or the name of the package in an upstream repository (e.g.,
256   # pip).
257   PACKAGE=$1
258   shift
259   # The name of the package to build.  Defaults to $PACKAGE.
260   PACKAGE_NAME=${1:-$PACKAGE}
261   shift
262   # Optional: the vendor of the package.  Should be "Curoverse, Inc." for
263   # packages of our own software.  Passed to fpm --vendor.
264   VENDOR=$1
265   shift
266   # The type of source package.  Passed to fpm -s.  Default "python".
267   PACKAGE_TYPE=${1:-python}
268   shift
269   # Optional: the package version number.  Passed to fpm -v.
270   VERSION=$1
271   shift
272
273   case "$PACKAGE_TYPE" in
274       python)
275           # All Arvados Python2 packages depend on Python 2.7.
276           # Make sure we build with that for consistency.
277           set -- "$@" --python-bin python2.7 \
278               --python-easyinstall "$EASY_INSTALL2" \
279               --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
280               --depends "$PYTHON2_PACKAGE"
281           ;;
282       python3)
283           # fpm does not actually support a python3 package type.  Instead
284           # we recognize it as a convenience shortcut to add several
285           # necessary arguments to fpm's command line later, after we're
286           # done handling positional arguments.
287           PACKAGE_TYPE=python
288           set -- "$@" --python-bin python3 \
289               --python-easyinstall "$EASY_INSTALL3" \
290               --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
291               --depends "$PYTHON3_PACKAGE"
292           ;;
293   esac
294
295   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
296   if [ python = "$PACKAGE_TYPE" ]; then
297     COMMAND_ARR+=(--exclude=\*/{dist,site}-packages/tests/\*)
298   fi
299
300   if [[ "$PACKAGE_NAME" != "$PACKAGE" ]]; then
301     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
302   fi
303
304   if [[ "$VENDOR" != "" ]]; then
305     COMMAND_ARR+=('--vendor' "$VENDOR")
306   fi
307
308   if [[ "$VERSION" != "" ]]; then
309     COMMAND_ARR+=('-v' "$VERSION")
310   fi
311
312   # Append remaining function arguments directly to fpm's command line.
313   for i; do
314     COMMAND_ARR+=("$i")
315   done
316
317   # Append --depends X and other arguments specified by fpm-info.sh in
318   # the package source dir. These are added last so they can override
319   # the arguments added by this script.
320   declare -a fpm_args=()
321   declare -a fpm_depends=()
322   if [[ -d "$PACKAGE" ]]; then
323       FPM_INFO="$PACKAGE/fpm-info.sh"
324   else
325       FPM_INFO="${WORKSPACE}/backports/${PACKAGE_TYPE}-${PACKAGE}/fpm-info.sh"
326   fi
327   if [[ -e "$FPM_INFO" ]]; then
328       debug_echo "Loading fpm overrides from $FPM_INFO"
329       source "$FPM_INFO"
330   fi
331   for i in "${fpm_depends[@]}"; do
332     COMMAND_ARR+=('--depends' "$i")
333   done
334   COMMAND_ARR+=("${fpm_args[@]}")
335
336   COMMAND_ARR+=("$PACKAGE")
337
338   debug_echo -e "\n${COMMAND_ARR[@]}\n"
339
340   FPM_RESULTS=$("${COMMAND_ARR[@]}")
341   FPM_EXIT_CODE=$?
342
343   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
344 }
345
346 # verify build results
347 fpm_verify () {
348   FPM_EXIT_CODE=$1
349   shift
350   FPM_RESULTS=$@
351
352   FPM_PACKAGE_NAME=''
353   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
354     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
355   fi
356
357   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
358     EXITCODE=1
359     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
360     echo
361     echo $FPM_RESULTS
362     echo
363   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
364     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
365   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
366     echo "Error building package for $1:\n $FPM_RESULTS"
367   fi
368 }
369
370 if [[ -f /etc/profile.d/rvm.sh ]]; then
371   source /etc/profile.d/rvm.sh
372 fi
373
374 # Make all files world-readable -- jenkins runs with umask 027, and has checked
375 # out our git tree here
376 chmod o+r "$WORKSPACE" -R
377
378 # More cleanup - make sure all executables that we'll package are 755
379 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
380
381 # Now fix our umask to something better suited to building and publishing
382 # gems and packages
383 umask 0022
384
385 debug_echo "umask is" `umask`
386
387 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
388   mkdir -p $WORKSPACE/packages/$TARGET
389 fi
390
391 # Perl packages
392 debug_echo -e "\nPerl packages\n"
393
394 cd "$WORKSPACE/sdk/perl"
395
396 if [[ -e Makefile ]]; then
397   make realclean >"$STDOUT_IF_DEBUG"
398 fi
399 find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
400     -delete
401 rm -rf install
402
403 perl Makefile.PL INSTALL_BASE=install >"$STDOUT_IF_DEBUG" && \
404     make install INSTALLDIRS=perl >"$STDOUT_IF_DEBUG" && \
405     fpm_build install/lib/=/usr/share libarvados-perl \
406     "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man && \
407     mv libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
408
409 # Ruby gems
410 debug_echo -e "\nRuby gems\n"
411
412 if type rvm-exec >/dev/null 2>&1; then
413   FPM_GEM_PREFIX=$(rvm-exec system gem environment gemdir)
414 else
415   FPM_GEM_PREFIX=$(gem environment gemdir)
416 fi
417
418 cd "$WORKSPACE/sdk/ruby"
419 handle_ruby_gem arvados
420
421 cd "$WORKSPACE/sdk/cli"
422 handle_ruby_gem arvados-cli
423
424 # Python packages
425 debug_echo -e "\nPython packages\n"
426
427 cd "$WORKSPACE/sdk/pam"
428 handle_python_package
429
430 cd "$WORKSPACE/sdk/python"
431 handle_python_package
432
433 cd "$WORKSPACE/services/fuse"
434 handle_python_package
435
436 cd "$WORKSPACE/services/nodemanager"
437 handle_python_package
438
439 # arvados-src
440 (
441     set -e
442
443     cd "$WORKSPACE"
444     COMMIT_HASH=$(format_last_commit_here "%H")
445
446     SRC_BUILD_DIR=$(mktemp -d)
447     git clone $DASHQ_UNLESS_DEBUG --branch "$COMMIT_HASH" "$WORKSPACE/.git" "$SRC_BUILD_DIR"
448     cd "$SRC_BUILD_DIR"
449     echo "$COMMIT_HASH" >git-commit.version
450
451     cd "$SRC_BUILD_DIR"
452     PKG_VERSION=$(version_from_git)
453     cd $WORKSPACE/packages/$TARGET
454     fpm_build $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
455
456     rm -r "$SRC_BUILD_DIR"
457 )
458
459 # Keep
460 export GOPATH=$(mktemp -d)
461 mkdir -p "$GOPATH/src/git.curoverse.com"
462 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
463
464 # keepstore
465 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/keepstore"
466 PKG_VERSION=$(version_from_git)
467 go get "git.curoverse.com/arvados.git/services/keepstore"
468 cd $WORKSPACE/packages/$TARGET
469 fpm_build $GOPATH/bin/keepstore=/usr/bin/keepstore keepstore 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Keepstore is the Keep storage daemon, accessible to clients on the LAN"
470
471 # Get GO SDK version
472 cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
473 GO_SDK_VERSION=$(version_from_git)
474 GO_SDK_TIMESTAMP=$(timestamp_from_git)
475
476 # keepproxy
477 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/keepproxy"
478 KEEPPROXY_VERSION=$(version_from_git)
479 KEEPPROXY_TIMESTAMP=$(timestamp_from_git)
480
481 if [[ "$GO_SDK_TIMESTAMP" -gt "$KEEPPROXY_TIMESTAMP" ]]; then
482   PKG_VERSION=$GO_SDK_VERSION
483 else
484   PKG_VERSION=$KEEPPROXY_VERSION
485 fi
486
487 go get "git.curoverse.com/arvados.git/services/keepproxy"
488 cd $WORKSPACE/packages/$TARGET
489 fpm_build $GOPATH/bin/keepproxy=/usr/bin/keepproxy keepproxy 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Keepproxy makes a Keep cluster accessible to clients that are not on the LAN"
490
491 # datamanager
492 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/datamanager"
493 DATAMANAGER_VERSION=$(version_from_git)
494 DATAMANAGER_TIMESTAMP=$(timestamp_from_git)
495
496 if [[ "$GO_SDK_TIMESTAMP" -gt "$DATAMANAGER_TIMESTAMP" ]]; then
497   PKG_VERSION=$GO_SDK_VERSION
498 else
499   PKG_VERSION=$DATAMANAGER_VERSION
500 fi
501
502 go get "git.curoverse.com/arvados.git/services/datamanager"
503 cd $WORKSPACE/packages/$TARGET
504 fpm_build $GOPATH/bin/datamanager=/usr/bin/arvados-data-manager arvados-data-manager 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Datamanager ensures block replication levels, reports on disk usage and determines which blocks should be deleted when space is needed."
505
506 # arv-git-httpd
507 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/arv-git-httpd"
508 ARVGITHTTPD_VERSION=$(version_from_git)
509 ARVGITHTTPD_TIMESTAMP=$(timestamp_from_git)
510
511 if [[ "$GO_SDK_TIMESTAMP" -gt "$ARVGITHTTPD_TIMESTAMP" ]]; then
512   PKG_VERSION=$GO_SDK_VERSION
513 else
514   PKG_VERSION=$ARVGITHTTPD_VERSION
515 fi
516
517 go get "git.curoverse.com/arvados.git/services/arv-git-httpd"
518 cd $WORKSPACE/packages/$TARGET
519 fpm_build $GOPATH/bin/arv-git-httpd=/usr/bin/arvados-git-httpd arvados-git-httpd 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Provides authenticated http access to Arvados-hosted git repositories."
520
521 # crunchstat
522 cd "$GOPATH/src/git.curoverse.com/arvados.git/services/crunchstat"
523 PKG_VERSION=$(version_from_git)
524 go get "git.curoverse.com/arvados.git/services/crunchstat"
525 cd $WORKSPACE/packages/$TARGET
526 fpm_build $GOPATH/bin/crunchstat=/usr/bin/crunchstat crunchstat 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=Crunchstat gathers cpu/memory/network statistics of running Crunch jobs"
527
528 # The Python SDK
529 # Please resist the temptation to add --no-python-fix-name to the fpm call here
530 # (which would remove the python- prefix from the package name), because this
531 # package is a dependency of arvados-fuse, and fpm can not omit the python-
532 # prefix from only one of the dependencies of a package...  Maybe I could
533 # whip up a patch and send it upstream, but that will be for another day. Ward,
534 # 2014-05-15
535 cd $WORKSPACE/packages/$TARGET
536 rm -rf "$WORKSPACE/sdk/python/build"
537 fpm_build $WORKSPACE/sdk/python "${PYTHON2_PKG_PREFIX}-arvados-python-client" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/python/arvados_python_client.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Python SDK" --deb-recommends=git
538
539 # The PAM module
540 if [[ $TARGET =~ debian|ubuntu ]]; then
541     cd $WORKSPACE/packages/$TARGET
542     rm -rf "$WORKSPACE/sdk/pam/build"
543     fpm_build $WORKSPACE/sdk/pam libpam-arvados 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/pam/arvados_pam.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=PAM module for authenticating shell logins using Arvados API tokens" --depends libpam-python
544 fi
545
546 # The FUSE driver
547 # Please see comment about --no-python-fix-name above; we stay consistent and do
548 # not omit the python- prefix first.
549 cd $WORKSPACE/packages/$TARGET
550 rm -rf "$WORKSPACE/services/fuse/build"
551 fpm_build $WORKSPACE/services/fuse "${PYTHON2_PKG_PREFIX}-arvados-fuse" 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/fuse/arvados_fuse.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Keep FUSE driver"
552
553 # The node manager
554 cd $WORKSPACE/packages/$TARGET
555 rm -rf "$WORKSPACE/services/nodemanager/build"
556 fpm_build $WORKSPACE/services/nodemanager arvados-node-manager 'Curoverse, Inc.' 'python' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/nodemanager/arvados_node_manager.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados node manager"
557
558 # The Docker image cleaner
559 cd $WORKSPACE/packages/$TARGET
560 rm -rf "$WORKSPACE/services/dockercleaner/build"
561 fpm_build $WORKSPACE/services/dockercleaner arvados-docker-cleaner 'Curoverse, Inc.' 'python3' "$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/dockercleaner/arvados_docker_cleaner.egg-info/PKG-INFO)" "--url=https://arvados.org" "--description=The Arvados Docker image cleaner"
562
563 # A few dependencies
564 for deppkg in "${PYTHON_BACKPORTS[@]}"; do
565     outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON2_PKG_PREFIX}-/")
566     fpm_build "$deppkg" "$outname"
567 done
568
569 # Python 3 dependencies
570 for deppkg in "${PYTHON3_BACKPORTS[@]}"; do
571     outname=$(echo "$deppkg" | sed -e 's/^python-//' -e 's/[<=>].*//' -e 's/_/-/g' -e "s/^/${PYTHON3_PKG_PREFIX}-/")
572     # The empty string is the vendor argument: these aren't Curoverse software.
573     fpm_build "$deppkg" "$outname" "" python3
574 done
575
576 # Build the API server package
577
578 cd "$WORKSPACE/services/api"
579
580 API_VERSION=$(version_from_git)
581 PACKAGE_NAME=arvados-api-server
582
583 if [[ ! -d "$WORKSPACE/services/api/tmp" ]]; then
584   mkdir $WORKSPACE/services/api/tmp
585 fi
586
587
588 bundle install --path vendor/bundle >"$STDOUT_IF_DEBUG"
589
590 /usr/bin/git rev-parse HEAD > git-commit.version
591
592 cd $WORKSPACE/packages/$TARGET
593
594 # Annoyingly, we require a database.yml file for rake assets:precompile to work. So for now,
595 # we do that in the upgrade script.
596 # TODO: add bogus database.yml file so we can precompile the assets and put them in the
597 # package. Then remove that database.yml file again. It has to be a valid file though.
598 #RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile
599
600 # This is the complete package with vendor/bundle included.
601 # It's big, so we do not build it by default.
602 if [[ "$BUILD_BUNDLE_PACKAGES" != 0 ]]; then
603   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados API server - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}-with-bundle" "-v" "$API_VERSION" "-x" "var/www/arvados-api/current/tmp" "-x" "var/www/arvados-api/current/log" "-x" "var/www/arvados-api/current/vendor/cache/*" "-x" "var/www/arvados-api/current/coverage" "-x" "var/www/arvados-api/current/Capfile*" "-x" "var/www/arvados-api/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/postinst.sh" "$WORKSPACE/services/api/=/var/www/arvados-api/current" "$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/arvados-api-server-upgrade.sh=/usr/local/bin/arvados-api-server-upgrade.sh")
604
605   debug_echo -e "\n${COMMAND_ARR[@]}\n"
606
607   FPM_RESULTS=$("${COMMAND_ARR[@]}")
608   FPM_EXIT_CODE=$?
609   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
610 fi
611
612 # Build the 'bare' package without vendor/bundle.
613 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados API server - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}" "-v" "$API_VERSION" "-x" "var/www/arvados-api/current/tmp" "-x" "var/www/arvados-api/current/log" "-x" "var/www/arvados-api/current/vendor/bundle" "-x" "var/www/arvados-api/current/vendor/cache/*" "-x" "var/www/arvados-api/current/coverage" "-x" "var/www/arvados-api/current/Capfile*" "-x" "var/www/arvados-api/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/postinst.sh" "$WORKSPACE/services/api/=/var/www/arvados-api/current" "$RUN_BUILD_PACKAGES_PATH/arvados-api-server-extras/arvados-api-server-upgrade.sh=/usr/local/bin/arvados-api-server-upgrade.sh")
614
615 debug_echo -e "\n${COMMAND_ARR[@]}\n"
616
617 FPM_RESULTS=$("${COMMAND_ARR[@]}")
618 FPM_EXIT_CODE=$?
619 fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
620
621 # API server package build done
622
623 # Build the workbench server package
624
625 cd "$WORKSPACE/apps/workbench"
626
627 WORKBENCH_VERSION=$(version_from_git)
628 PACKAGE_NAME=arvados-workbench
629
630 if [[ ! -d "$WORKSPACE/apps/workbench/tmp" ]]; then
631   mkdir $WORKSPACE/apps/workbench/tmp
632 fi
633
634 bundle install --path vendor/bundle >"$STDOUT_IF_DEBUG"
635
636 /usr/bin/git rev-parse HEAD > git-commit.version
637
638 # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
639 # and we want that in the package, so it's easier to not exclude the tmp directory
640 # from the package - empty it instead.
641 rm -rf $WORKSPACE/apps/workbench/tmp/*
642
643 # Set up application.yml and production.rb so that asset precompilation works
644 \cp config/application.yml.example config/application.yml -f
645 \cp config/environments/production.rb.example config/environments/production.rb -f
646 sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
647
648 RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
649
650 if [[ "$?" != "0" ]]; then
651   echo "ERROR: Asset precompilation failed"
652   EXITCODE=1
653 fi
654
655 cd $WORKSPACE/packages/$TARGET
656
657 # This is the complete package with vendor/bundle included.
658 # It's big, so we do not build it by default.
659 if [[ "$BUILD_BUNDLE_PACKAGES" != 0 ]]; then
660
661   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados Workbench - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}-with-bundle" "-v" "$WORKBENCH_VERSION" "-x" "var/www/arvados-workbench/current/log" "-x" "var/www/arvados-workbench/current/vendor/cache/*" "-x" "var/www/arvados-workbench/current/coverage" "-x" "var/www/arvados-workbench/current/Capfile*" "-x" "var/www/arvados-workbench/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/postinst.sh" "$WORKSPACE/apps/workbench/=/var/www/arvados-workbench/current" "$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/arvados-workbench-upgrade.sh=/usr/local/bin/arvados-workbench-upgrade.sh")
662
663   debug_echo -e "\n${COMMAND_ARR[@]}\n"
664
665   FPM_RESULTS=$("${COMMAND_ARR[@]}")
666   FPM_EXIT_CODE=$?
667   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
668 fi
669
670 # Build the 'bare' package without vendor/bundle.
671
672 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "--vendor='Curoverse, Inc.'" "--url='https://arvados.org'" "--description='Arvados Workbench - Arvados is a free and open source platform for big data science.'" "--license='GNU Affero General Public License, version 3.0'" "-s" "dir" "-t" "$FORMAT" "-n" "${PACKAGE_NAME}" "-v" "$WORKBENCH_VERSION" "-x" "var/www/arvados-workbench/current/log" "-x" "var/www/arvados-workbench/current/vendor/bundle" "-x" "var/www/arvados-workbench/current/vendor/cache/*" "-x" "var/www/arvados-workbench/current/coverage" "-x" "var/www/arvados-workbench/current/Capfile*" "-x" "var/www/arvados-workbench/current/config/deploy*" "--after-install=$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/postinst.sh" "$WORKSPACE/apps/workbench/=/var/www/arvados-workbench/current" "$RUN_BUILD_PACKAGES_PATH/arvados-workbench-extras/arvados-workbench-upgrade.sh=/usr/local/bin/arvados-workbench-upgrade.sh")
673
674 debug_echo -e "\n${COMMAND_ARR[@]}\n"
675
676 FPM_RESULTS=$("${COMMAND_ARR[@]}")
677 FPM_EXIT_CODE=$?
678 fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
679
680 # Workbench package build done
681 # clean up temporary GOPATH
682 rm -rf "$GOPATH"
683
684 exit $EXITCODE